## 3-Vorzeichen-Tiefe (bereits normierte Version fuer den Test)

# input: residuals (Residuen des Modells unter einem Parameter)
# output: normierte Version der 3-Vorzeichen-Tiefe

linear_3depth <- function(residuals){
  N <- length(residuals)
  S <- cumsum(sign(residuals))
  diffs <- (c( S, S[N]- S))^2
  result <- ( 3/4*diffs[N] - 3/2* sum(diffs)/N)/(N-2)*(1+1/(N-1)) +
    3/4*(1+1/(N-1))*(1+2/(N-2))
  return(result)
}

###############################################################################
## Beispiel: quadratische Regression
set.seed(9719)
x <- seq(-2, 2, 0.25) # Regressoren
N <- length(x)
y <- x^2 + 2 + rnorm(N) # Modell: x^2 + 2
res <- y - (-x^2 + 3) # vorgeschlagenes Modell: - x^2 + 4

linear_3depth(res) # normierter Wert (fuer den Test zu verwenden)
linear_3depth(res)/N + 1/4 # Definition der Tiefe aus Uebungsblatt 14

