## 4-Vorzeichen-Tiefe (bereits normierte Version fuer den Test)

# input: residuals (Residuen des Modells unter einem Parameter)
# output: normierte Version der 4-Vorzeichen-Tiefe

linear_4depth <- function(residuals){
  N <- length(residuals)
  S <- cumsum(sign(residuals))
  diffs <- (S[N]- S)^2
  
  # Hilfsfunktion
  linearprod <- function(residuals = residuals, K = 4){
    M <- length(which(sign(residuals) == -1))
    N <- length(residuals)
    C <- 0
    for(i in 0:K){
      C <- C + choose(M,i) * choose(N-M,K-i) * (-1)^i
    }
    return(C)
  }
  
  
  result <- N^3/((N-1) * (N-2) * (N-3)) * 3 * (1/4 - 1/(4*N) * S[N]^2
                                               - 1/N^2 * sum(S^2) + 1/N^2 * sum(diffs) - 1/N^3 * sum((2 * (N - 1:N) + 1) * S^2)
                                               - 1/N^3 * sum( (2 * 1:N - 1)* diffs) + 2/N^3 * sum(S)^2
                                               + (1/(4 * N^2) - 1/(2 * N^3)) * (S[N]^2 - N)) + N * linearprod(residuals, 4)/(choose(N,4) * 8)
  return(result)
}

###############################################################################
## Beispiel: quadratische Regression
set.seed(9719)
x <- seq(-2, 2, 0.25) # Regressoren
N <- length(x)
y <- x^2 + 2 + rnorm(N) # Modell: x^2 + 2
res <- y - (-x^2 + 3) # vorgeschlagenes Modell: - x^2 + 4

linear_4depth(res) # normierter Wert (fuer den Test zu verwenden)
linear_4depth(res)/N + 1/8 # Definition der Tiefe aus Uebungsblatt 14

